import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jbpm.api.NewDeployment;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.TaskQuery;
import org.jbpm.api.task.Task;
import org.jbpm.test.JbpmTestCase;


public class SimpleProcessTest extends JbpmTestCase {
	
	@Override
	protected void setUp() throws Exception {
		super.setUp();
		NewDeployment deployment = repositoryService.createDeployment();
		deployment.addResourceFromClasspath("jbpm_testprozess_simple.bpmn.xml");
		String deployId = deployment.deploy();
		registerDeployment(deployId);
		System.out.println("Prozess (ID:"+deployId+") deployed!");
	}

	public void testProcessCall() {
		Map<String, Object> variables = new HashMap<String, Object>();
		variables.put("var1", "Zeichenkette");
		ProcessInstance pi = executionService.startProcessInstanceByKey("jbpm_testprozess_simple", variables);
		
		// userTask testen
		System.out.println("UserTask Test beginnt");
		TaskQuery taskQuery = taskService.createTaskQuery();
		List<Task> allTasks = taskQuery.list();
		System.out.println("Anzahl Tasks: "+allTasks.size());
		assertEquals(1, allTasks.size());
		// userTask komplettieren
		taskService.completeTask(allTasks.get(0).getId());
		System.out.println("UserTask abgeschlossen");
		
		// serviceTask prüfen
		System.out.println("ServiceTask beginnt");
		assertNotNull(pi.getId());
		System.out.println("Prozess Instanz existiert: "+pi.getId());
		assertEquals("Zeichenkette!", executionService.getVariable(pi.getId(), "returnVar"));
		
		// prüfen, ob Prozess beendet wurde
		assertProcessInstanceEnded(pi);
	}
}
